# generate-collections [![NPM version](https://img.shields.io/npm/v/generate-collections.svg?style=flat)](https://www.npmjs.com/package/generate-collections) [![NPM downloads](https://img.shields.io/npm/dm/generate-collections.svg?style=flat)](https://npmjs.org/package/generate-collections) [![Build Status](https://img.shields.io/travis/generate/generate-collections.svg?style=flat)](https://travis-ci.org/generate/generate-collections)

Add the docs, includes, badges, and layouts collections, along with a few generic defaults to your generator.

You might also be interested in [generate-file](https://github.com/generate/generate-file).

## Install

Install as a `devDependency` with [npm](https://www.npmjs.com/):

```sh
$ npm install --save-dev generate-collections
```

## Usage

Use as a plugin, to initialize commonly used [view collections](#collections-created) (no views are actually added to the collections).

```js
module.exports = function(app) {
  app.use(require('generate-collections'));
  // do other generator stuff
};
```

## Collections created

Adds the following view collections to your generator:

### Renderable

Templates for files intended to be written to the file system.

* `files`

**Example usage**

```js
app.files('templates/*.md');
```

### Layouts

Templates to be used as layouts (for "wrapping" other templates or content):

* `layouts`

```js
app.layouts('templates/layouts/*.md');
```

### Partials

Templates to be used as partials (for injecting into other templates)

* `includes`
* `badges`
* `docs`

```js
app.partials('templates/partials/*.md');
```

## Smart plugin

This generator follows [base](https://github.com/node-base/base) "smart plugin" conventions, so it can be used as a plugin with any of the following libraries:

* [generate](https://github.com/generate/generate): in your local `generator.js` file or globally installed `generate` generator.
* [assemble](https://github.com/assemble/assemble): in your local `assemblefile.js` file or globally installed `assemble` generator.
* [update](https://github.com/update/update): in your local `updatefile.js` file or globally installed `update` generator.
* [verb](https://github.com/verbose/verb): in your local `verbfile.js` file or globally installed `verb` generator.

## About

### Related projects

* [generate-license](https://www.npmjs.com/package/generate-license): Generate a license file for a GitHub project. | [homepage](https://github.com/generate/generate-license "Generate a license file for a GitHub project.")
* [generate-mocha](https://www.npmjs.com/package/generate-mocha): Generate mocha test files. | [homepage](https://github.com/generate/generate-mocha "Generate mocha test files.")
* [generate-node](https://www.npmjs.com/package/generate-node): Generate a node.js project, with everything you need to begin writing code and easily publish… [more](https://github.com/generate/generate-node) | [homepage](https://github.com/generate/generate-node "Generate a node.js project, with everything you need to begin writing code and easily publish the project to npm.")

### Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](../../issues/new).

### Building docs

_(This document was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme) (a [verb](https://github.com/verbose/verb) generator), please don't edit the readme directly. Any changes to the readme must be made in [.verb.md](.verb.md).)_

To generate the readme and API documentation with [verb](https://github.com/verbose/verb):

```sh
$ npm install -g verb verb-generate-readme && verb
```

### Running tests

Install dev dependencies:

```sh
$ npm install -d && npm test
```

### Author

**Jon Schlinkert**

* [github/jonschlinkert](https://github.com/jonschlinkert)
* [twitter/jonschlinkert](http://twitter.com/jonschlinkert)

### License

Copyright © 2016, [Jon Schlinkert](https://github.com/jonschlinkert).
Released under the [MIT license](https://github.com/generate/generate-collections/blob/master/LICENSE).

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.1.29, on August 09, 2016._